%define anolis_release 4
%bcond_without pam

Summary:    Job spooling tools
Name:       at
Version:    3.2.5
Release:    %{anolis_release}%{?dist}
# http://packages.debian.org/changelogs/pool/main/a/at/current/copyright
# + install-sh is MIT license with changes under Public Domain
License:    GPLv3+ and GPLv2+ and ISC and MIT and Public Domain
URL:        http://ftp.debian.org/debian/pool/main/a/at

Source:     http://software.calhariz.com/at/at_%{version}.orig.tar.gz
# git upstream source git://git.debian.org/git/collab-maint/at.git
Source1:    pam_atd
Source3:    atd.sysconf
Source5:    atd.systemd

Patch1:      0001-at-aarch64.patch
Patch2:      0002-at-3.2.5-make.patch
Patch3:      0003-at-3.2.5-pam.patch

BuildRequires: gcc
BuildRequires: flex flex-static bison autoconf
BuildRequires: libselinux-devel >= 1.27.9
BuildRequires: perl(Test::Harness)
BuildRequires: perl(Test::More)
BuildRequires: systemd-rpm-macros

%if %{with pam}
BuildRequires: pam-devel
%endif
Conflicts: crontabs <= 1.5
BuildRequires: make

Requires(post): systemd-units
Requires(preun): systemd-units
Requires(postun): systemd-units

# at-sysvinit subpackage dropped
Obsoletes: at-sysvinit < 3.1.16-1

%description
At and batch read commands from standard input or from a specified
file. At allows you to specify that a command will be run at a
particular time. Batch will execute commands when the system load
levels drop to a particular level. Both commands use user's shell.

You should install the at package if you need a utility for
time-oriented job control. Note: If it is a recurring job that will
need to be repeated at the same time every day/week, etc. you should
use crontab instead.

%package doc
Summary: Documentation for at
Requires: %{name} = %{version}-%{release}
License: GPLv3+ and GPLv2+ and ISC and MIT and Public Domain
BuildArch: noarch

%description doc

This package provides README, changlog and timespec for at.

%prep
%autosetup -N
cp %{SOURCE1} .
%autopatch -p1

%build
# uselles files
rm -f lex.yy.* y.tab.*

%configure --with-atspool=%{_localstatedir}/spool/at/spool \
    --with-jobdir=%{_localstatedir}/spool/at \
    --with-daemon_username=root  \
    --with-daemon_groupname=root \
    --with-selinux \
    %{?with_pam:--with-pam}

make

%install
make install \
    DAEMON_USERNAME=`id -nu` \
    DAEMON_GROUPNAME=`id -ng` \
    DESTDIR=%{buildroot} \
    sbindir=%{_prefix}/sbin \
    bindir=%{_bindir} \
    prefix=%{_prefix} \
    exec_prefix=%{_prefix} \
    docdir=%{_prefix}/doc \
    mandir=%{_mandir} \
    etcdir=%{_sysconfdir} \
    ATJOB_DIR=%{_localstatedir}/spool/at \
    ATSPOOL_DIR=%{_localstatedir}/spool/at/spool \
    INSTALL_ROOT_USER=`id -nu` \
    INSTALL_ROOT_GROUP=`id -nu`;

echo > %{buildroot}%{_sysconfdir}/at.deny
mkdir docs
cp  %{buildroot}%{_prefix}/doc/at/* docs/

mkdir -p %{buildroot}%{_sysconfdir}/pam.d
install -p -m 644 %{SOURCE1} %{buildroot}%{_sysconfdir}/pam.d/atd

mkdir -p %{buildroot}/etc/sysconfig
install -p -m 644 %{SOURCE3} %{buildroot}/etc/sysconfig/atd

# install systemd initscript
mkdir -p %{buildroot}/%{_unitdir}/
install -p -m 644 %{SOURCE5} %{buildroot}/%{_unitdir}/atd.service

# remove unpackaged files from the buildroot
rm -r  %{buildroot}%{_prefix}/doc

%check
make test

%post
touch %{_localstatedir}/spool/at/.SEQ
chmod 600 %{_localstatedir}/spool/at/.SEQ
chown root:root %{_localstatedir}/spool/at/.SEQ
%systemd_post atd.service

%preun
%systemd_preun atd.service

%postun
%systemd_postun_with_restart atd.service

%triggerun -- at < 3.1.12-6
# Save the current service runlevel info
# User must manually run systemd-sysv-convert --apply atd
# to migrate them to systemd targets
/usr/bin/systemd-sysv-convert --save atd

# The package is allowed to autostart:
/bin/systemctl enable atd.service >/dev/null 2>&1

/sbin/chkconfig --del atd >/dev/null 2>&1 || :
/bin/systemctl try-restart atd.service >/dev/null 2>&1 || :
/bin/systemctl daemon-reload >/dev/null 2>&1 || :

%files
%license Copyright COPYING
%attr(0644,root,root)       %config(noreplace) %{_sysconfdir}/at.deny
%attr(0644,root,root)       %config(noreplace) %{_sysconfdir}/sysconfig/atd
%attr(0700,root,root)       %dir %{_localstatedir}/spool/at
%attr(0600,root,root)       %verify(not md5 size mtime) %ghost %{_localstatedir}/spool/at/.SEQ
%attr(0700,root,root)       %dir %{_localstatedir}/spool/at/spool
%attr(0644,root,root)       %config(noreplace) %{_sysconfdir}/pam.d/atd
%{_sbindir}/atrun
%attr(0755,root,root)       %{_sbindir}/atd
%{_mandir}/man*/*
%{_bindir}/batch
%{_bindir}/atrm
%{_bindir}/atq
%attr(4755,root,root)       %{_bindir}/at
%attr(0644,root,root)       /%{_unitdir}/atd.service

%files doc
%doc README timespec ChangeLog

%changelog
* Wed May 21 2025 zhoujiajia111 <zjl02254423@alibaba-inc.com> - 3.2.5-4
- Rebuild for remove inappropriate build dependencies.

* Mon Dec 05 2022 Feng Su <sufeng@linux.alibaba.com> - 3.2.5-3
- add doc sub package
- standardize patch name

* Thu Oct 27 2022 happy_orange <songnannan@linux.alibaba.com> - 3.2.5-2
- bugfix the error in preun

* Mon Mar 07 2022 Yuanhong Peng <yummypeng@linux.alibaba.com> - 3.2.5-1
- Init from upstream v3.2.5
- Fix build error: No mail command specified
